<?php
$photo = isset($_GET["photo"]) ? $_GET["photo"] : false;
$allowedFormats = array("jpg", "jpeg");
$thumbEnd = "_t";
define("THUMBNAIL_MAX_WIDTH", 100);
define("THUMBNAIL_MAX_HEIGHT", 100);
define("PHOTO_AS_LINK", true);

function findPageTitle($dir, $photoName) {
  global $galleryName;
  
  $files = findFiles($dir);
  $rank = array_search($photoName, $files);
  if ($rank === false) {
    return $galleryName;
  }
  return "fotografie ".($rank + 1)."/".count($files)." ($galleryName)";
}

function writePhoto($dir, $photoName) {
  if (!file_exists($photoName)) {
    writeThumbnails($dir);
    return;
  }
  $files = findFiles($dir);
  $rank = array_search($photoName, $files);
  if ($rank === false) {
    writeThumbnails($dir);
    return;
  }
  $info = getimagesize($photoName);
  if ($info === false) {
    writeThumbnails($dir);
    return;
  }
  
  $prev = null;
  $next = null;
  if ($rank > 0) {
    $prev = $files[$rank-1];
  }
  if ($rank < count($files)-1) {
    $next = $files[$rank+1];
  }
  
  writePagination ($prev, $next);
  writeGalleryInfo();
  writePhotoInfo($rank, $files);
  $photoTitle = findPhotoTitle($photoName);
  
  echo "<p class = 'image'>";
  if (PHOTO_AS_LINK and $next !== null) {
    echo "<a href = '?photo=$next'>";
  }
  echo "<img src = '$photoName' ".$info[3]." alt = '$photoTitle' />";
  if (PHOTO_AS_LINK and $next !== null) {
    echo "</a>";
  }
  echo "</p>\n";
  
  echo "<p class = 'backLink'>";
  echo "<a href = 'index.php'>zpět na výběr fotografií</a>";
  echo "</p>\n";
  
  keyPagination($prev, $next);
}

function writePagination($prev, $next) {
  echo "<p class = 'pagination'>";
  if ($prev !== null) {
    echo "<a href = '?photo=$prev'>předchozí fotografie</a>\n";
  } else {
    echo "<span class = 'lineThr'>předchozí fotografie</span>\n";
  }
  
  
  if ($next !== null) {
    echo "<a href = '?photo=$next'>následující fotografie</a>";
  } else {
    echo "<span class = 'lineThr'>následující fotografie</span>";
  }
  echo "</p>\n";
}

function keyPagination($prev, $next) {
echo "<script type=\"text/javascript\">

document.onkeyup = KeyCheck;

function KeyCheck(e) {
   var address = window.location.href;
   var posOf = address.lastIndexOf('=');
   var addressON = address.substring(0, posOf+1);
   
   var KeyID = (window.event) ? event.keyCode : e.keyCode;
   
   switch(KeyID) {
     case 27:
     //escape
     var addressEsc = address.substring(0, address.lastIndexOf('?'));
     window.location.href = addressEsc;
     break;
     
     case 37:
     //doleva
     ";
     if ($prev !== null)
       echo "
       var addressLeft = addressON + '$prev';
       window.location.href = addressLeft;
       
       "; 
     echo "break;
     
     case 32:
     case 39:
     //doprava
     ";
     if ($next !== null)
       echo "
       var addressRight = addressON + '$next';
       window.location.href = addressRight;
       "; 
     echo "break;
     
   }
}
</script>
  ";
}

function writeGalleryInfo() {
  global $galleryName, $date;
  //echo "<p class = 'galleryInfo'>";
  echo "<h1 class = 'displayImage'>";
  echo $galleryName." ($date)";
  //echo "</p>\n";
  echo "</h1>\n";
}

function writePhotoInfo($rank, $files) {
  echo "<p class = 'photoInfo'>";
  echo ($rank+1).". fotografie z ".count($files);
  echo "</p>\n";
}

function findPhotoTitle($filename) {
  return $filename;
}



function writeThumbnails($dir) {
  global $galleryName, $date;
  
  echo "<p class = 'backLink'><a href = '..'>návrat na výběr všech galerií</a></p>\n";
  echo "<h1>$galleryName</h1>\n";
  echo "<h2>$date</h2>\n";
  echo "<hr />";
  $files = findFiles($dir);
  echo "<p class = 'imageThumbs'>\n";
  foreach ($files as $oneFile) {
    $thumbName = createThumbFilename($oneFile);
    if (!file_exists($thumbName)) {
      createThumbnail($oneFile);
    }
    $info = getimagesize($thumbName);
    if ($info === false) continue;
    echo "<a href = '?photo=$oneFile'>";
    echo "<img src = '$thumbName' alt = 'otevřít obrázek' ".$info[3]." />";
    echo "</a>\n";
  }
  echo "</p>\n";
  echo "<p class = 'backLink'><a href = '..'>návrat na výběr všech galerií</a></p>\n";
}

function findFiles($dir) {
  global $allowedFormats, $thumbEnd;
  
  if ($dir == "") {
    $directory = opendir(".");
    $path = "";
  } else {
    $directory = opendir($dir);
    $path = $dir."/";
  }
  
  $photos = array();
  while ($file = readdir($directory)){
    $start = strrpos($file, ".")+1;
    if ($start <= 0) {
      continue;
    }
    
    $ext = strtolower(substr($file, $start));
    $filename = strtolower(substr($file, 0, $start-1));
    if (substr($filename, -strlen($thumbEnd)) == $thumbEnd) {
      //file is thumbnail
      continue;
    }
    
    if (in_array($ext, $allowedFormats)) {
      $photos[] = $path.$file; 
    }
    
  }
  
  closedir($directory);
  natsort($photos);
  $sorted = array_values($photos);
  return $sorted;
}

function createThumbnail($filename) {
  @$image = imagecreatefromjpeg($filename);
  if ($image === false) {
    return false;
  }
  
  $coef = 1;
  $height = imagesy($image);
  $width = imagesx($image);
   
  $wCoef = THUMBNAIL_MAX_WIDTH/$width;
  $hCoef = THUMBNAIL_MAX_HEIGHT/$height;
  
  $coef = min($wCoef, $hCoef);
    if ($coef < 1) {
    $width = $width*$coef;
    $height = $height*$coef;
  }
  
  return resizeTo($image, $width, $height, createThumbFilename($filename));
}

/**
 * Zmeni velikost obrazku a zlozi jej do zadaneho souboru.
 *   
 * @param resource $image puvodni resource obrazku
 * @param int $width nova sirka obrazku
 * @param int $height nova vyska obrazku
 * @param string $filename jmeno vysledneho obrazku
 * @return boolean true v pripade uspechu, jinak false
 */
function resizeTo($image, $width, $height, $filename) {
  $smallImage = imagecreatetruecolor($width, $height);
  $copy = imagecopyresampled($smallImage, $image, 0, 0, 0, 0, $width, $height, imagesx($image), imagesy($image)); 
  if (!$copy) {
    return false;
  }
  
  $save = imagejpeg($smallImage, $filename, 85);
  if (!$save) {
    return false;
  }
  return true;
}

function createThumbFilename($filename) {
  global $thumbEnd;
  
  $start = strrpos($filename, ".")+1;
  if ($start <= 0) {
    return $filename.$thumbEnd;
  }
  
  $ext = strtolower(substr($filename, $start));
  $filename = strtolower(substr($filename, 0, $start-1));
  return $filename.$thumbEnd.".".$ext;
}

function writeIndex() {
  echo "<h1>Fotogalerie - rozcestí</h1>\n";
  $dir = opendir(".");
  
  $directories = array();
  while ($photoDir = readdir($dir)){
    if ($photoDir == "." || $photoDir == "..") continue;
    if (filetype($photoDir) !== "dir") continue; 
    if (!file_exists("$photoDir/gallery_data.php")) continue;
    
    include "$photoDir/gallery_data.php";
    if (!(isset($privateGallery) and $privateGallery)) {
    
      while (isset($directories[$startDate])) {
        $startDate++;
      }
      $directories[$startDate] = array(
        "name" => $galleryName, 
        "date" => $date,
        "galleryDir" => $photoDir,
        "imageDir" => $imageDir
      );
    }
    unset($galleryName, $date, $imageDir, $startDate, $privateGallery);
  }
  
  krsort($directories);
  $lastYear = -1;
  
  foreach ($directories as $date => $oneGallery) {
    $year = date("Y", $date);
    if ($year !== $lastYear) {
      echo "<h2 class = 'left'>$year</h2>\n";
      $lastYear = $year;
    }
    echo "<p class = 'galleryIndex'>";
      echo "<a href = '$oneGallery[galleryDir]'>$oneGallery[name] ($oneGallery[date])</a>";
    echo "</p>\n";
  }
  if (count($directories) == 0) {
    echo "<p class = 'galleryIndex'>";
    echo "Nebyla nalezena žádná galerie.";
    echo "</p>\n";
  }
}
?>
